package com.mdp.voice;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Toolkit;

import javax.swing.JFrame;

import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyListener;

import java.awt.event.KeyEvent;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.net.PasswordAuthentication;

import javax.swing.BorderFactory;

import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JCheckBox;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.JPasswordField;
import javax.swing.JButton;

import javax.swing.JOptionPane;

public class MakeCall extends JFrame implements ActionListener, KeyListener, WindowListener {

    private JPanel headerPane;
    private JPanel contentPane;
    private JPanel footerPane;
    private JLabel lConnect = new JLabel("Person's IP Address to call: ");
    private JTextField tConnect = new JTextField();
    private JButton bOK = new JButton("Call Now!");
    private JLabel lStatus = new JLabel();

    /**
     * Get connection info
     * @param a
     */
    public void getConnectionInfo() {
        this.addWindowListener(this);
        
        this.setSize(new Dimension(400, 200));
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        //this.setDefaultCloseOperation(EXIT_ON_CLOSE);

        setLocation((screenSize.width - 400) / 2, // and centered
                (screenSize.height - 200) / 2);


        headerPane = new JPanel();
        headerPane.setBackground(Color.white);

        JLabel sLabel = new JLabel("MDPVoice!");
        sLabel.setFont(new Font("SansSerif", Font.BOLD, 18));

        headerPane.setLayout(new FlowLayout(FlowLayout.LEFT));
        headerPane.add(sLabel);

        headerPane.setBorder(BorderFactory.createEtchedBorder());

        contentPane = new JPanel();

        contentPane.setBorder(BorderFactory.createEtchedBorder());

        contentPane.setLayout(null);

        contentPane.add(lConnect);
        contentPane.add(tConnect);

        lConnect.setBounds(10, 10, 125, 25);
        tConnect.setBounds(150, 10, 150, 25);


        footerPane = new JPanel();
        footerPane.setBorder(BorderFactory.createEtchedBorder());

        footerPane.add(bOK);

        bOK.addActionListener(this);



        getContentPane().setLayout(new BorderLayout());
        getContentPane().add(headerPane, BorderLayout.NORTH);
        getContentPane().add(contentPane, BorderLayout.CENTER);
        getContentPane().add(footerPane, BorderLayout.SOUTH);


        setVisible(true);

    }

    /**
     * Method fired on an action event (Button click etc.)
     */
    public synchronized void actionPerformed(ActionEvent e) {
        try {

            // String command = e.getActionCommand();

            notify();

            /*
             * Close auth window
             */
            this.dispose();

        } catch (Exception ex) {
            Util.logger(ex.toString());
        }

    }

    /**
     * Set status message
     * @param s
     */
    public void setStatus(String s) {
        lStatus.setText(s);
    }

    /** Handle the key typed event from the text field. */
    public void keyTyped(KeyEvent e) {

        if (e.getKeyChar() == KeyEvent.VK_ENTER) {
            bOK.doClick();
            //pwdAuthentication = new PasswordAuthentication( tUserID.getText(), tPassword.getPassword() );
        }
    }

    /** Handle the key-pressed event from the text field. */
    public void keyPressed(KeyEvent e) {
        //Alert.show( "KP"  +  e.getID() );
    }

    /** Handle the key-released event from the text field. */
    public void keyReleased(KeyEvent e) {
        //Alert.show( "KR"  +  e.getID() );	
    }

    public synchronized String getTarget() {
        try {

            wait();

        } catch (Exception e) {
        }
        return tConnect.getText();
    }

    /*
     * Window listener interfaces
     */
    public void windowClosed(WindowEvent e) {
    }

    public void windowOpened(WindowEvent e) {
    }

    public void windowIconified(WindowEvent e) {
    }

    public void windowDeiconified(WindowEvent e) {
    }

    public void windowActivated(WindowEvent e) {
    }

    public void windowDeactivated(WindowEvent e) {
    }

    public void windowGainedFocus(WindowEvent e) {
    }

    public void windowLostFocus(WindowEvent e) {
    }

    public void windowStateChanged(WindowEvent e) {
    }

    /**
     * Override closing event...
     * 
     * IF the user closes the window then we stop.
     * 
     */
    public void windowClosing( WindowEvent e ) {
        /*
         * Ask the user if they really want to quit.
         * 
         * If so, terminate the JVM
         */
        this.setAlwaysOnTop(false);

        if (JOptionPane.showConfirmDialog(
                null,
                "Closing this window will terminate MyDevplanet's VOICE app..\n\nDo you really want to quit?\n\n",
                "MDPVoice", JOptionPane.YES_NO_OPTION,
                JOptionPane.QUESTION_MESSAGE) == JOptionPane.YES_OPTION) {
            this.dispose();	// Close window.. not necessary. but clean.
            System.exit(0);
        } else {
            this.setAlwaysOnTop(true);
        }
    }
}
